
import os
import re

def list_files_with_pattern(directory, pattern):
    matches = []
    for root, dirs, files in os.walk(directory):
        for filename in files:
            if re.match(pattern, filename):
                matches.append(os.path.join(root, filename))
    return matches



